/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Error;
import com.squareup.connect.models.Order;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * Defines the fields that are included in the response body of a request to the BatchRetrieveOrders endpoint.
 */
@ApiModel(description = "Defines the fields that are included in the response body of a request to the BatchRetrieveOrders endpoint.")

public class BatchRetrieveOrdersResponse {
  @JsonProperty("orders")
  private List<Order> orders = new ArrayList<Order>();

  @JsonProperty("errors")
  private List<Error> errors = new ArrayList<Error>();

  public BatchRetrieveOrdersResponse orders(List<Order> orders) {
    this.orders = orders;
    return this;
  }

  public BatchRetrieveOrdersResponse addOrdersItem(Order ordersItem) {
    this.orders.add(ordersItem);
    return this;
  }

   /**
   * The requested orders. This will omit any requested orders that do not exist.
   * @return orders
  **/
  @ApiModelProperty(value = "The requested orders. This will omit any requested orders that do not exist.")
  public List<Order> getOrders() {
    return orders;
  }

  public void setOrders(List<Order> orders) {
    this.orders = orders;
  }

  public BatchRetrieveOrdersResponse errors(List<Error> errors) {
    this.errors = errors;
    return this;
  }

  public BatchRetrieveOrdersResponse addErrorsItem(Error errorsItem) {
    this.errors.add(errorsItem);
    return this;
  }

   /**
   * Any errors that occurred during the request.
   * @return errors
  **/
  @ApiModelProperty(value = "Any errors that occurred during the request.")
  public List<Error> getErrors() {
    return errors;
  }

  public void setErrors(List<Error> errors) {
    this.errors = errors;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BatchRetrieveOrdersResponse batchRetrieveOrdersResponse = (BatchRetrieveOrdersResponse) o;
    return Objects.equals(this.orders, batchRetrieveOrdersResponse.orders) &&
        Objects.equals(this.errors, batchRetrieveOrdersResponse.errors);
  }

  @Override
  public int hashCode() {
    return Objects.hash(orders, errors);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BatchRetrieveOrdersResponse {\n");
    
    sb.append("    orders: ").append(toIndentedString(orders)).append("\n");
    sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

