/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Money;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * Additional details about CASH type payments.
 */
@ApiModel(description = "Additional details about CASH type payments.")

public class CashPaymentDetails {
  @JsonProperty("buyer_supplied_money")
  private Money buyerSuppliedMoney = null;

  @JsonProperty("change_back_money")
  private Money changeBackMoney = null;

  public CashPaymentDetails buyerSuppliedMoney(Money buyerSuppliedMoney) {
    this.buyerSuppliedMoney = buyerSuppliedMoney;
    return this;
  }

   /**
   * The amount and currency of the money supplied by the buyer.
   * @return buyerSuppliedMoney
  **/
  @ApiModelProperty(required = true, value = "The amount and currency of the money supplied by the buyer.")
  public Money getBuyerSuppliedMoney() {
    return buyerSuppliedMoney;
  }

  public void setBuyerSuppliedMoney(Money buyerSuppliedMoney) {
    this.buyerSuppliedMoney = buyerSuppliedMoney;
  }

  public CashPaymentDetails changeBackMoney(Money changeBackMoney) {
    this.changeBackMoney = changeBackMoney;
    return this;
  }

   /**
   * The amount of change due back to the buyer. Read Only field calculated from the amount_money and buyer_supplied_money fields.
   * @return changeBackMoney
  **/
  @ApiModelProperty(value = "The amount of change due back to the buyer. Read Only field calculated from the amount_money and buyer_supplied_money fields.")
  public Money getChangeBackMoney() {
    return changeBackMoney;
  }

  public void setChangeBackMoney(Money changeBackMoney) {
    this.changeBackMoney = changeBackMoney;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CashPaymentDetails cashPaymentDetails = (CashPaymentDetails) o;
    return Objects.equals(this.buyerSuppliedMoney, cashPaymentDetails.buyerSuppliedMoney) &&
        Objects.equals(this.changeBackMoney, cashPaymentDetails.changeBackMoney);
  }

  @Override
  public int hashCode() {
    return Objects.hash(buyerSuppliedMoney, changeBackMoney);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CashPaymentDetails {\n");
    
    sb.append("    buyerSuppliedMoney: ").append(toIndentedString(buyerSuppliedMoney)).append("\n");
    sb.append("    changeBackMoney: ").append(toIndentedString(changeBackMoney)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

