/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * A &#x60;CatalogItemOptionValue&#x60; links an item variation to an item option as an item option value. For example, a t-shirt item may offer a color option and a size option. An item option value would represent each variation of t-shirt: For example, \&quot;Color:Red, Size:Small\&quot; or \&quot;Color:Blue, Size:Medium\&quot;.
 */
@ApiModel(description = "A `CatalogItemOptionValue` links an item variation to an item option as an item option value. For example, a t-shirt item may offer a color option and a size option. An item option value would represent each variation of t-shirt: For example, \"Color:Red, Size:Small\" or \"Color:Blue, Size:Medium\".")

public class CatalogItemOptionValueForItemVariation {
  @JsonProperty("item_option_id")
  private String itemOptionId = null;

  @JsonProperty("item_option_value_id")
  private String itemOptionValueId = null;

  public CatalogItemOptionValueForItemVariation itemOptionId(String itemOptionId) {
    this.itemOptionId = itemOptionId;
    return this;
  }

   /**
   * The unique id of an item option.
   * @return itemOptionId
  **/
  @ApiModelProperty(value = "The unique id of an item option.")
  public String getItemOptionId() {
    return itemOptionId;
  }

  public void setItemOptionId(String itemOptionId) {
    this.itemOptionId = itemOptionId;
  }

  public CatalogItemOptionValueForItemVariation itemOptionValueId(String itemOptionValueId) {
    this.itemOptionValueId = itemOptionValueId;
    return this;
  }

   /**
   * The unique id of the selected value for the item option.
   * @return itemOptionValueId
  **/
  @ApiModelProperty(value = "The unique id of the selected value for the item option.")
  public String getItemOptionValueId() {
    return itemOptionValueId;
  }

  public void setItemOptionValueId(String itemOptionValueId) {
    this.itemOptionValueId = itemOptionValueId;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CatalogItemOptionValueForItemVariation catalogItemOptionValueForItemVariation = (CatalogItemOptionValueForItemVariation) o;
    return Objects.equals(this.itemOptionId, catalogItemOptionValueForItemVariation.itemOptionId) &&
        Objects.equals(this.itemOptionValueId, catalogItemOptionValueForItemVariation.itemOptionValueId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(itemOptionId, itemOptionValueId);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CatalogItemOptionValueForItemVariation {\n");
    
    sb.append("    itemOptionId: ").append(toIndentedString(itemOptionId)).append("\n");
    sb.append("    itemOptionValueId: ").append(toIndentedString(itemOptionValueId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

