/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.CatalogObject;
import com.squareup.connect.models.Error;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * 
 */
@ApiModel(description = "")

public class CreateCatalogImageResponse {
  @JsonProperty("errors")
  private List<Error> errors = new ArrayList<Error>();

  @JsonProperty("image")
  private CatalogObject image = null;

  public CreateCatalogImageResponse errors(List<Error> errors) {
    this.errors = errors;
    return this;
  }

  public CreateCatalogImageResponse addErrorsItem(Error errorsItem) {
    this.errors.add(errorsItem);
    return this;
  }

   /**
   * Information on any errors encountered.
   * @return errors
  **/
  @ApiModelProperty(value = "Information on any errors encountered.")
  public List<Error> getErrors() {
    return errors;
  }

  public void setErrors(List<Error> errors) {
    this.errors = errors;
  }

  public CreateCatalogImageResponse image(CatalogObject image) {
    this.image = image;
    return this;
  }

   /**
   * The newly created `CatalogImage` including a Square-generated URL for each image.
   * @return image
  **/
  @ApiModelProperty(value = "The newly created `CatalogImage` including a Square-generated URL for each image.")
  public CatalogObject getImage() {
    return image;
  }

  public void setImage(CatalogObject image) {
    this.image = image;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateCatalogImageResponse createCatalogImageResponse = (CreateCatalogImageResponse) o;
    return Objects.equals(this.errors, createCatalogImageResponse.errors) &&
        Objects.equals(this.image, createCatalogImageResponse.image);
  }

  @Override
  public int hashCode() {
    return Objects.hash(errors, image);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateCatalogImageResponse {\n");
    
    sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
    sb.append("    image: ").append(toIndentedString(image)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

