/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * Represents communication preferences for the customer profile.
 */
@ApiModel(description = "Represents communication preferences for the customer profile.")

public class CustomerPreferences {
  @JsonProperty("email_unsubscribed")
  private Boolean emailUnsubscribed = null;

  public CustomerPreferences emailUnsubscribed(Boolean emailUnsubscribed) {
    this.emailUnsubscribed = emailUnsubscribed;
    return this;
  }

   /**
   * The customer has unsubscribed from receiving marketing campaign emails.
   * @return emailUnsubscribed
  **/
  @ApiModelProperty(value = "The customer has unsubscribed from receiving marketing campaign emails.")
  public Boolean getEmailUnsubscribed() {
    return emailUnsubscribed;
  }

  public void setEmailUnsubscribed(Boolean emailUnsubscribed) {
    this.emailUnsubscribed = emailUnsubscribed;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CustomerPreferences customerPreferences = (CustomerPreferences) o;
    return Objects.equals(this.emailUnsubscribed, customerPreferences.emailUnsubscribed);
  }

  @Override
  public int hashCode() {
    return Objects.hash(emailUnsubscribed);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CustomerPreferences {\n");
    
    sb.append("    emailUnsubscribed: ").append(toIndentedString(emailUnsubscribed)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

