/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Money;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * The hourly wage rate that an employee will earn on a &#x60;Shift&#x60; for doing the job specified by the &#x60;title&#x60; property of this object.
 */
@ApiModel(description = "The hourly wage rate that an employee will earn on a `Shift` for doing the job specified by the `title` property of this object.")

public class EmployeeWage {
  @JsonProperty("id")
  private String id = null;

  @JsonProperty("employee_id")
  private String employeeId = null;

  @JsonProperty("title")
  private String title = null;

  @JsonProperty("hourly_rate")
  private Money hourlyRate = null;

  public EmployeeWage id(String id) {
    this.id = id;
    return this;
  }

   /**
   * UUID for this object.
   * @return id
  **/
  @ApiModelProperty(value = "UUID for this object.")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public EmployeeWage employeeId(String employeeId) {
    this.employeeId = employeeId;
    return this;
  }

   /**
   * The `Employee` that this wage is assigned to.
   * @return employeeId
  **/
  @ApiModelProperty(required = true, value = "The `Employee` that this wage is assigned to.")
  public String getEmployeeId() {
    return employeeId;
  }

  public void setEmployeeId(String employeeId) {
    this.employeeId = employeeId;
  }

  public EmployeeWage title(String title) {
    this.title = title;
    return this;
  }

   /**
   * The job title that this wage relates to.
   * @return title
  **/
  @ApiModelProperty(value = "The job title that this wage relates to.")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public EmployeeWage hourlyRate(Money hourlyRate) {
    this.hourlyRate = hourlyRate;
    return this;
  }

   /**
   * Can be a custom-set hourly wage or the calculated effective hourly wage based on annual wage and hours worked per week.
   * @return hourlyRate
  **/
  @ApiModelProperty(value = "Can be a custom-set hourly wage or the calculated effective hourly wage based on annual wage and hours worked per week.")
  public Money getHourlyRate() {
    return hourlyRate;
  }

  public void setHourlyRate(Money hourlyRate) {
    this.hourlyRate = hourlyRate;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    EmployeeWage employeeWage = (EmployeeWage) o;
    return Objects.equals(this.id, employeeWage.id) &&
        Objects.equals(this.employeeId, employeeWage.employeeId) &&
        Objects.equals(this.title, employeeWage.title) &&
        Objects.equals(this.hourlyRate, employeeWage.hourlyRate);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, employeeId, title, hourlyRate);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class EmployeeWage {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    employeeId: ").append(toIndentedString(employeeId)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    hourlyRate: ").append(toIndentedString(hourlyRate)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

