/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * The information needed to define a custom unit, provided by the seller.
 */
@ApiModel(description = "The information needed to define a custom unit, provided by the seller.")

public class MeasurementUnitCustom {
  @JsonProperty("name")
  private String name = null;

  @JsonProperty("abbreviation")
  private String abbreviation = null;

  public MeasurementUnitCustom name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The name of the custom unit, for example \"bushel\".
   * @return name
  **/
  @ApiModelProperty(required = true, value = "The name of the custom unit, for example \"bushel\".")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public MeasurementUnitCustom abbreviation(String abbreviation) {
    this.abbreviation = abbreviation;
    return this;
  }

   /**
   * The abbreviation of the custom unit, such as \"bsh\" (bushel). This appears in the cart for the Point of Sale app, and in reports.
   * @return abbreviation
  **/
  @ApiModelProperty(required = true, value = "The abbreviation of the custom unit, such as \"bsh\" (bushel). This appears in the cart for the Point of Sale app, and in reports.")
  public String getAbbreviation() {
    return abbreviation;
  }

  public void setAbbreviation(String abbreviation) {
    this.abbreviation = abbreviation;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MeasurementUnitCustom measurementUnitCustom = (MeasurementUnitCustom) o;
    return Objects.equals(this.name, measurementUnitCustom.name) &&
        Objects.equals(this.abbreviation, measurementUnitCustom.abbreviation);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, abbreviation);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MeasurementUnitCustom {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    abbreviation: ").append(toIndentedString(abbreviation)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

