/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * Represents a Square seller.
 */
@ApiModel(description = "Represents a Square seller.")

public class Merchant {
  @JsonProperty("id")
  private String id = null;

  @JsonProperty("business_name")
  private String businessName = null;

  @JsonProperty("country")
  private String country = null;

  @JsonProperty("language_code")
  private String languageCode = null;

  @JsonProperty("currency")
  private String currency = null;

  @JsonProperty("status")
  private String status = null;

  public Merchant id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The Square-issued ID of the merchant.
   * @return id
  **/
  @ApiModelProperty(value = "The Square-issued ID of the merchant.")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public Merchant businessName(String businessName) {
    this.businessName = businessName;
    return this;
  }

   /**
   * The business name of the merchant.
   * @return businessName
  **/
  @ApiModelProperty(value = "The business name of the merchant.")
  public String getBusinessName() {
    return businessName;
  }

  public void setBusinessName(String businessName) {
    this.businessName = businessName;
  }

  public Merchant country(String country) {
    this.country = country;
    return this;
  }

   /**
   * The country code associated with the merchant account, in ISO 3166-1-alpha-2 format. See [Country](#type-country) for possible values
   * @return country
  **/
  @ApiModelProperty(required = true, value = "The country code associated with the merchant account, in ISO 3166-1-alpha-2 format. See [Country](#type-country) for possible values")
  public String getCountry() {
    return country;
  }

  public void setCountry(String country) {
    this.country = country;
  }

  public Merchant languageCode(String languageCode) {
    this.languageCode = languageCode;
    return this;
  }

   /**
   * The language code associated with the merchant account, in BCP 47 format.
   * @return languageCode
  **/
  @ApiModelProperty(value = "The language code associated with the merchant account, in BCP 47 format.")
  public String getLanguageCode() {
    return languageCode;
  }

  public void setLanguageCode(String languageCode) {
    this.languageCode = languageCode;
  }

  public Merchant currency(String currency) {
    this.currency = currency;
    return this;
  }

   /**
   * The currency associated with the merchant account, in ISO 4217 format. See [Currency](#type-currency) for possible values
   * @return currency
  **/
  @ApiModelProperty(value = "The currency associated with the merchant account, in ISO 4217 format. See [Currency](#type-currency) for possible values")
  public String getCurrency() {
    return currency;
  }

  public void setCurrency(String currency) {
    this.currency = currency;
  }

  public Merchant status(String status) {
    this.status = status;
    return this;
  }

   /**
   * The merchant status, active or inactive. See [MerchantStatus](#type-merchantstatus) for possible values
   * @return status
  **/
  @ApiModelProperty(value = "The merchant status, active or inactive. See [MerchantStatus](#type-merchantstatus) for possible values")
  public String getStatus() {
    return status;
  }

  public void setStatus(String status) {
    this.status = status;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Merchant merchant = (Merchant) o;
    return Objects.equals(this.id, merchant.id) &&
        Objects.equals(this.businessName, merchant.businessName) &&
        Objects.equals(this.country, merchant.country) &&
        Objects.equals(this.languageCode, merchant.languageCode) &&
        Objects.equals(this.currency, merchant.currency) &&
        Objects.equals(this.status, merchant.status);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, businessName, country, languageCode, currency, status);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Merchant {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    businessName: ").append(toIndentedString(businessName)).append("\n");
    sb.append("    country: ").append(toIndentedString(country)).append("\n");
    sb.append("    languageCode: ").append(toIndentedString(languageCode)).append("\n");
    sb.append("    currency: ").append(toIndentedString(currency)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

