/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Error;
import com.squareup.connect.models.Order;
import com.squareup.connect.models.OrderEntry;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * Only one of &#x60;order_entries&#x60; or &#x60;orders&#x60; fields will be set, depending on whether &#x60;return_entries&#x60; was set on the [SearchOrdersRequest](#type-searchorderrequest).
 */
@ApiModel(description = "Only one of `order_entries` or `orders` fields will be set, depending on whether `return_entries` was set on the [SearchOrdersRequest](#type-searchorderrequest).")

public class SearchOrdersResponse {
  @JsonProperty("order_entries")
  private List<OrderEntry> orderEntries = new ArrayList<OrderEntry>();

  @JsonProperty("orders")
  private List<Order> orders = new ArrayList<Order>();

  @JsonProperty("cursor")
  private String cursor = null;

  @JsonProperty("errors")
  private List<Error> errors = new ArrayList<Error>();

  public SearchOrdersResponse orderEntries(List<OrderEntry> orderEntries) {
    this.orderEntries = orderEntries;
    return this;
  }

  public SearchOrdersResponse addOrderEntriesItem(OrderEntry orderEntriesItem) {
    this.orderEntries.add(orderEntriesItem);
    return this;
  }

   /**
   * List of `OrderEntries` that fit the query conditions. Populated only if `return_entries` was set to `true` in the request.
   * @return orderEntries
  **/
  @ApiModelProperty(value = "List of `OrderEntries` that fit the query conditions. Populated only if `return_entries` was set to `true` in the request.")
  public List<OrderEntry> getOrderEntries() {
    return orderEntries;
  }

  public void setOrderEntries(List<OrderEntry> orderEntries) {
    this.orderEntries = orderEntries;
  }

  public SearchOrdersResponse orders(List<Order> orders) {
    this.orders = orders;
    return this;
  }

  public SearchOrdersResponse addOrdersItem(Order ordersItem) {
    this.orders.add(ordersItem);
    return this;
  }

   /**
   * List of `Order` objects that match query conditions. Populated only if `return_entries` in the request is set to `false`.
   * @return orders
  **/
  @ApiModelProperty(value = "List of `Order` objects that match query conditions. Populated only if `return_entries` in the request is set to `false`.")
  public List<Order> getOrders() {
    return orders;
  }

  public void setOrders(List<Order> orders) {
    this.orders = orders;
  }

  public SearchOrdersResponse cursor(String cursor) {
    this.cursor = cursor;
    return this;
  }

   /**
   * The pagination cursor to be used in a subsequent request. If unset, this is the final response. See [Pagination](https://developer.squareup.com/docs/basics/api101/pagination) for more information.
   * @return cursor
  **/
  @ApiModelProperty(value = "The pagination cursor to be used in a subsequent request. If unset, this is the final response. See [Pagination](https://developer.squareup.com/docs/basics/api101/pagination) for more information.")
  public String getCursor() {
    return cursor;
  }

  public void setCursor(String cursor) {
    this.cursor = cursor;
  }

  public SearchOrdersResponse errors(List<Error> errors) {
    this.errors = errors;
    return this;
  }

  public SearchOrdersResponse addErrorsItem(Error errorsItem) {
    this.errors.add(errorsItem);
    return this;
  }

   /**
   * `Errors` encountered during the search.
   * @return errors
  **/
  @ApiModelProperty(value = "`Errors` encountered during the search.")
  public List<Error> getErrors() {
    return errors;
  }

  public void setErrors(List<Error> errors) {
    this.errors = errors;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SearchOrdersResponse searchOrdersResponse = (SearchOrdersResponse) o;
    return Objects.equals(this.orderEntries, searchOrdersResponse.orderEntries) &&
        Objects.equals(this.orders, searchOrdersResponse.orders) &&
        Objects.equals(this.cursor, searchOrdersResponse.cursor) &&
        Objects.equals(this.errors, searchOrdersResponse.errors);
  }

  @Override
  public int hashCode() {
    return Objects.hash(orderEntries, orders, cursor, errors);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SearchOrdersResponse {\n");
    
    sb.append("    orderEntries: ").append(toIndentedString(orderEntries)).append("\n");
    sb.append("    orders: ").append(toIndentedString(orders)).append("\n");
    sb.append("    cursor: ").append(toIndentedString(cursor)).append("\n");
    sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

