/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.ShiftQuery;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * A request for a filtered and sorted set of &#x60;Shift&#x60; objects.
 */
@ApiModel(description = "A request for a filtered and sorted set of `Shift` objects.")

public class SearchShiftsRequest {
  @JsonProperty("query")
  private ShiftQuery query = null;

  @JsonProperty("limit")
  private Integer limit = null;

  @JsonProperty("cursor")
  private String cursor = null;

  public SearchShiftsRequest query(ShiftQuery query) {
    this.query = query;
    return this;
  }

   /**
   * Query filters.
   * @return query
  **/
  @ApiModelProperty(value = "Query filters.")
  public ShiftQuery getQuery() {
    return query;
  }

  public void setQuery(ShiftQuery query) {
    this.query = query;
  }

  public SearchShiftsRequest limit(Integer limit) {
    this.limit = limit;
    return this;
  }

   /**
   * number of resources in a page (200 by default).
   * minimum: 1
   * maximum: 200
   * @return limit
  **/
  @ApiModelProperty(value = "number of resources in a page (200 by default).")
  public Integer getLimit() {
    return limit;
  }

  public void setLimit(Integer limit) {
    this.limit = limit;
  }

  public SearchShiftsRequest cursor(String cursor) {
    this.cursor = cursor;
    return this;
  }

   /**
   * opaque cursor for fetching the next page.
   * @return cursor
  **/
  @ApiModelProperty(value = "opaque cursor for fetching the next page.")
  public String getCursor() {
    return cursor;
  }

  public void setCursor(String cursor) {
    this.cursor = cursor;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SearchShiftsRequest searchShiftsRequest = (SearchShiftsRequest) o;
    return Objects.equals(this.query, searchShiftsRequest.query) &&
        Objects.equals(this.limit, searchShiftsRequest.limit) &&
        Objects.equals(this.cursor, searchShiftsRequest.cursor);
  }

  @Override
  public int hashCode() {
    return Objects.hash(query, limit, cursor);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SearchShiftsRequest {\n");
    
    sb.append("    query: ").append(toIndentedString(query)).append("\n");
    sb.append("    limit: ").append(toIndentedString(limit)).append("\n");
    sb.append("    cursor: ").append(toIndentedString(cursor)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

