/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * 
 */
@ApiModel(description = "")

public class UpdateItemModifierListsRequest {
  @JsonProperty("item_ids")
  private List<String> itemIds = new ArrayList<String>();

  @JsonProperty("modifier_lists_to_enable")
  private List<String> modifierListsToEnable = new ArrayList<String>();

  @JsonProperty("modifier_lists_to_disable")
  private List<String> modifierListsToDisable = new ArrayList<String>();

  public UpdateItemModifierListsRequest itemIds(List<String> itemIds) {
    this.itemIds = itemIds;
    return this;
  }

  public UpdateItemModifierListsRequest addItemIdsItem(String itemIdsItem) {
    this.itemIds.add(itemIdsItem);
    return this;
  }

   /**
   * The IDs of the catalog items associated with the CatalogModifierList objects being updated.
   * @return itemIds
  **/
  @ApiModelProperty(required = true, value = "The IDs of the catalog items associated with the CatalogModifierList objects being updated.")
  public List<String> getItemIds() {
    return itemIds;
  }

  public void setItemIds(List<String> itemIds) {
    this.itemIds = itemIds;
  }

  public UpdateItemModifierListsRequest modifierListsToEnable(List<String> modifierListsToEnable) {
    this.modifierListsToEnable = modifierListsToEnable;
    return this;
  }

  public UpdateItemModifierListsRequest addModifierListsToEnableItem(String modifierListsToEnableItem) {
    this.modifierListsToEnable.add(modifierListsToEnableItem);
    return this;
  }

   /**
   * The IDs of the CatalogModifierList objects to enable for the CatalogItem.
   * @return modifierListsToEnable
  **/
  @ApiModelProperty(value = "The IDs of the CatalogModifierList objects to enable for the CatalogItem.")
  public List<String> getModifierListsToEnable() {
    return modifierListsToEnable;
  }

  public void setModifierListsToEnable(List<String> modifierListsToEnable) {
    this.modifierListsToEnable = modifierListsToEnable;
  }

  public UpdateItemModifierListsRequest modifierListsToDisable(List<String> modifierListsToDisable) {
    this.modifierListsToDisable = modifierListsToDisable;
    return this;
  }

  public UpdateItemModifierListsRequest addModifierListsToDisableItem(String modifierListsToDisableItem) {
    this.modifierListsToDisable.add(modifierListsToDisableItem);
    return this;
  }

   /**
   * The IDs of the CatalogModifierList objects to disable for the CatalogItem.
   * @return modifierListsToDisable
  **/
  @ApiModelProperty(value = "The IDs of the CatalogModifierList objects to disable for the CatalogItem.")
  public List<String> getModifierListsToDisable() {
    return modifierListsToDisable;
  }

  public void setModifierListsToDisable(List<String> modifierListsToDisable) {
    this.modifierListsToDisable = modifierListsToDisable;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UpdateItemModifierListsRequest updateItemModifierListsRequest = (UpdateItemModifierListsRequest) o;
    return Objects.equals(this.itemIds, updateItemModifierListsRequest.itemIds) &&
        Objects.equals(this.modifierListsToEnable, updateItemModifierListsRequest.modifierListsToEnable) &&
        Objects.equals(this.modifierListsToDisable, updateItemModifierListsRequest.modifierListsToDisable);
  }

  @Override
  public int hashCode() {
    return Objects.hash(itemIds, modifierListsToEnable, modifierListsToDisable);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UpdateItemModifierListsRequest {\n");
    
    sb.append("    itemIds: ").append(toIndentedString(itemIds)).append("\n");
    sb.append("    modifierListsToEnable: ").append(toIndentedString(modifierListsToEnable)).append("\n");
    sb.append("    modifierListsToDisable: ").append(toIndentedString(modifierListsToDisable)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

