/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.api;

import com.squareup.connect.ApiClient;
import com.squareup.connect.ApiException;
import com.squareup.connect.Configuration;
import com.squareup.connect.auth.OAuth;
import com.squareup.connect.models.ListAdditionalRecipientReceivableRefundsResponse;
import com.squareup.connect.models.ListAdditionalRecipientReceivablesResponse;
import com.squareup.connect.utils.APITest;
import com.squareup.connect.utils.Account;
import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ReportingApi
 */
public class ReportingApiTest extends APITest {

    private final ApiClient defaultClient = Configuration.getDefaultApiClient();
    private final ReportingApi api = new ReportingApi();
    private String locationID;

    @Before
    public void setup() {
        Account account = accounts.get("US-Prod");
        OAuth oauth2 = (OAuth) defaultClient.getAuthentication("oauth2");
        oauth2.setAccessToken(account.accessToken);
        locationID = account.locationId;
    }

    /**
     * ListAdditionalRecipientReceivableRefunds
     *
     * Lists Additional Recipient Receivable Refunds for a particular location.  Max results per [page](#paginatingresults): 50
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listAdditionalRecipientReceivableRefundsTest() throws ApiException {
        String locationId = this.locationID;
        String beginTime = null;
        String endTime = null;
        String sortOrder = null;
        String cursor = null;
        ListAdditionalRecipientReceivableRefundsResponse response = api.listAdditionalRecipientReceivableRefunds(locationId, beginTime, endTime, sortOrder, cursor);
    }

    /**
     * ListAdditionalRecipientReceivables
     *
     * Lists Additional Recipient Receivables for a particular location.  Max results per [page](#paginatingresults): 50
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void listAdditionalRecipientReceivablesTest() throws ApiException {
        String locationId = this.locationID;
        String beginTime = null;
        String endTime = null;
        String sortOrder = null;
        String cursor = null;
        ListAdditionalRecipientReceivablesResponse response = api.listAdditionalRecipientReceivables(locationId, beginTime, endTime, sortOrder, cursor);
    }

}
